/*

	SmartGroupBarController -> SmartGroupBarUIController (cocoa)
	------------------------------------------------------------
	
	All we care about is 'title' and 'guid'
	
*/

/*********************************** Smart Bar ***************************************/
/*************************************************************************************/

/*
	Cocoa controller class 'SmartGroupController'
*/

var SmartGroupsArray = null;
function GetSmartGroup(uid) {
	if(!SmartGroupsArray)
		return null;
	
	var i, c = SmartGroupsArray.length;
	for(i=0; i<c; i=i+1) {
		if(SmartGroupsArray[i].valueForKey('uid') == uid) {
			return SmartGroupsArray[i];
		}
	}
}

$(function() {
	//Task actions popup menu (ie the ^* to right)
	$('div.tasks-smart-bar span#options.popup').mousedown(function(e) {
		SmartGroupBarController.showOptionsPopupNSMenu();
	});

	//Show/Hide the add task area
	$('#show-add-temp').click(function() {
		if($(this).hasClass('selected')) {
			hideAddTaskArea();
			$(this).find('img').attr('src', 'check_normal.png');
			$(this).removeClass('selected');
		} else {
			showAddTaskArea();
			$(this).find('img').attr('src', 'check_over.png');
			$(this).addClass('selected');
		}
	});

});

//depreciated
function visuallySelectSmartBarItem(item) {
	var hitem = $('span#'+item+'.sbitem');
	if(!hitem.hasClass('selected')) {
		hitem.closest('.smart-bar').find('.sbitem').removeClass('selected');
		hitem.addClass('selected');
	}
}

/*
 	Interaction from SmartGroupBarUIController for SmartGroups
*/

function UpdateItemWithSmartGroup(obj) {
	var item = UISmartItemWithIdentifier(obj.valueForKey('uid'));
	if(item.length < 1) {
		LayoutSmartGroupFilterItems(SmartGroupsArray);
	} else {
		item.text(obj.valueForKey('title'));
	}
}

function UpdateItemWithSmartGroupIdentifier(id) {
	UpdateItemWithSmartGroup(GetSmartGroup(id));
	UIAdjustOverflowSizingForBar($('#tasks-smart-bar.smart-bar'));
}

function LayoutSmartGroupFilterItems(smartArray) {
	SmartGroupsArray = smartArray;
	
	
	UIRemoveAllLeftSmartItems('tasks-smart-bar');
	var lc = UIGetLeftSmartItemsContainer('tasks-smart-bar');
	
	var i, c = smartArray.length;
	for(i=0; i<c; i=i+1) {
		var smart = smartArray[i];
		var title = smart.valueForKey('title');
		if(title) {
			lc.append("<span class='sbitem' id='"+ smart.valueForKey('uid') + "'>"+ smart.valueForKey('title') + "</span>");
		}
	}
	UIAdjustOverflowSizingForBar($('#tasks-smart-bar.smart-bar'));
}